#include "stdafx.h"
#include <stdio.h>
#include "..\HelloWorld.h"   // this header file was generated by javah

// helper functions to allocate and deallocate a string

static char *getStringToPrint()
{
	char	*str;

	str = new char [20];
	if (str != NULL)
	{
		strcpy(str, "Hello World!");
	}

	return str;
}

static void cleanupString(char	*str)
{
	delete [] str;
}

// example JNI code that is going to leak some memory so that we can test Memory Validator detecting a memory leak
// in Java JNI code

JNIEXPORT void JNICALL Java_HelloWorld_displayMessage(JNIEnv *env, jobject obj) 
{
	char	*str;

	// do it correctly (get string, print, tidy up)

	str = getStringToPrint();

	printf(str);
	printf("\n");

	cleanupString(str);

	// do it incorrectly (get string, print, forget to tidy up, will show as a leak in Memory Validator)

	str = getStringToPrint();

	printf(str);
	printf("\n");
}
